/*
 * 小程序项目
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class ProjectsController : BaseController
    {
        public ProjectsController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
        }

        #region 小程序项目列表

        /// <summary>
        /// 根据条件查询小程序项目列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(Projects data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            
            
            return View();
        }

        #endregion

        #region 根据条件查询小程序项目列表

        /// <summary>
        /// 小程序项目列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(Projects data, string UserIdRealName, string UserIdMobile, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("ProjectName", "1"); //项目名称
Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //所属用户真实姓名
if (!string.IsNullOrEmpty(UserIdRealName))
{
condition += " and UserId in (select UserId from UsersForRealName where RealName='" + UserIdRealName + "')";
}
//所属用户手机号
if (!string.IsNullOrEmpty(UserIdMobile))
{
condition += " and UserId in (select UserId from UsersForMobile where Mobile='" + UserIdMobile + "')";
}


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).IndexData("Projects", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["StatusName"] = dic["Status"].ToString() == "1" ? "正常" : "关闭";
//所属用户
int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
dic["UserIdRealName"] = userid_Users.RealName;
dic["UserIdMobile"] = userid_Users.Mobile;
dic.Remove("UserId");

            }
            return Json(obj);
        }

        #endregion

        #region 增加小程序项目

        /// <summary>
        /// 增加或修改小程序项目信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加小程序项目

        /// <summary>
        /// 增加或修改小程序项目信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(Projects data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("ProjectName", data.ProjectName); //项目名称
Fields.Add("ProjectDetail", data.ProjectDetail); //项目介绍
Fields.Add("ProjectContent", data.ProjectContent); //项目详情
Fields.Add("UserId", data.UserId); //所属用户

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Add("Projects", Fields, 0);
            AddSysLog(data.Id.ToString(), "Projects", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改小程序项目

        /// <summary>
        /// 增加或修改小程序项目信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            Projects editData = db.Projects.FirstOrDefault(m => m.Id == Id) ?? new Projects();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改小程序项目

        /// <summary>
        /// 增加或修改小程序项目信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(Projects data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("ProjectName", data.ProjectName); //项目名称
Fields.Add("ProjectDetail", data.ProjectDetail); //项目介绍
Fields.Add("ProjectContent", data.ProjectContent); //项目详情
Fields.Add("UserId", data.UserId); //所属用户

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("Projects", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"Projects","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除小程序项目信息

        /// <summary>
        /// 删除小程序项目信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"Projects","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("Projects", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"Projects","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("Projects", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"Projects","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("Projects", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Sort("Projects", Sort, Id);
            
            AddSysLog(Id.ToString(), "Projects", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.Projects.Add(new Projects()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "Projects", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(Projects data, string UserIdRealName, string UserIdMobile)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ProjectName", "1"); //项目名称
Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //所属用户真实姓名
if (!string.IsNullOrEmpty(UserIdRealName))
{
condition += " and UserId in (select UserId from UsersForRealName where RealName='" + UserIdRealName + "')";
}
//所属用户手机号
if (!string.IsNullOrEmpty(UserIdMobile))
{
condition += " and UserId in (select UserId from UsersForMobile where Mobile='" + UserIdMobile + "')";
}


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).IndexData("Projects", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["StatusName"] = dic["Status"].ToString() == "1" ? "正常" : "关闭";
//所属用户
int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
dic["UserIdRealName"] = userid_Users.RealName;
dic["UserIdMobile"] = userid_Users.Mobile;
dic.Remove("UserId");

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "Projects", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
